/* Declare a function handler component.
This component have a reference to one standart user defined C function
called when component is activated. */




#include "../defs.h"

#include "../mem.h"

#include "../array.h"

#include "../string.h"

#include "../node.h"

#include "../list.h"

#include "../polygon.h"

#include "../nodepol.h"

#include "../nodeint.h"

#include "../map.h"

#include "../math.h"

#include "../mesh.h"

#include "../sector.h"

#include "../nodesec.h"

#include "../refsys.h"

#include "../camsys.h"

#include "../nodesec.h"

#include "../lighttab.h"

#include "../eventtab.h"

#include "../scenery.h"

#include "../object.h"

#include "../nodeobj.h"

#include "../nodeptrv.h"

#include "nodecomp.h"

#include "cofuncha.h"



/* contructor - init with default component type
**********************************************************/
CComponentFunctionHandler::CComponentFunctionHandler ()
{
   m_dwMyTypeID = TYPE_FUNCTION_HANDLER;
   m_dwFunctionID = (DWORD) -1;
}



/* destructor
**********************************************************/
CComponentFunctionHandler::~CComponentFunctionHandler ()
{
}



/* Activate: do something acording the parameter pData1.
pData1 - if 0 - does nothing
            1 - signals function set
            2 - signals function execution
pData2 - if pData1 is 0 - not used
                      1 - the function ID to be used
                      2 - parameter to function
pData3 - if pData1 is 0 - not used
                      1 - not used
                      2 - parameter to function
return - if pData1 is 0 - 1 - ok / 0 - error
                      1 - 1 - ok / 0 - error
                      2 - value returned by function
**********************************************************/
PTRVAL CComponentFunctionHandler::mActivate ( PTRVAL pData1, PTRVAL pData2, PTRVAL pData3 )
{
   // make action acording pData1
   switch ( pData1 ) {

      case 1:
         m_dwFunctionID = (DWORD) pData2;
         return 1;
         break;

      case 2:           // call function
         return m_poMyObj->m_poScen->mExecuteFunction ( m_dwFunctionID, m_poMyObj, pData2, pData3 );
         break;

      default:
         return 0;
         break;
   }

   return 0;
}
